/// COPYRIGHT (C) 1997, 1998, 1999 SEAN K. BECHHOFER
/// and THE UNIVERSITY OF MANCHESTER, seanb@cs.man.ac.uk

////////////////////////////////////////////////////////////////////////////
/// FaCT Client                                                          ///
/// COPYRIGHT (C) 1997, 1998, 1999 SEAN K. BECHHOFER                     ///
/// and THE UNIVERSITY OF MANCHESTER                                     /// 
///					                                 ///
/// This program is free software; you can redistribute it and/or        ///
/// modify it under the terms of the GNU General Public License          ///
/// as published by the Free Software Foundation; either version 2       ///
/// of the License, or (at your option) any later version.               ///
///                                                                      ///
/// This program is distributed in the hope that it will be useful,      ///
/// but WITHOUT ANY WARRANTY; without even the implied warranty of       ///
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ///
/// GNU General Public License for more details.                         ///
///                                                                      ///
/// You should have received a copy of the GNU General Public License    ///
/// along with this program; if not, write to the Free Software          ///
/// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA            ///
/// 02111-1307, USA.                                                     ///
///                                                                      ///
/// Enquiries about FaCT should be directed to:                          ///
///                                                                      ///
/// email: horrocks@cs.man.ac.uk                                         ///
/// www:   http://www.cs.man.ac.uk/~horrocks                             ///
/// smail: Ian Horrocks, Department of Computer Science, Oxford Road,    ///
///       Manchester 467M13 9PL, United Kingdom                          ///
///                                                                      ///
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
///                                                                      ///
/// This class is intended to demonstrate how to write a Java client     ///
/// that will communicate with the FaCT description logic reasoner via   ///
/// the CORBA-based interface. It is not supported or maintained and no  ///
/// guarantees are supplied as to the quality or robustness of the code. ///
/// SKB, 4/10/99                                                         ///
///                                                                      ///
////////////////////////////////////////////////////////////////////////////

package img.fact.client;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;

public class ConceptDefinitionForm extends JFrame {

private JTextField name;
private JTextArea description;

  static final int CANCEL=0;
  static final int ACCEPT=1;
  
public JDialog jd;
  protected Frame parent;
private ActionListener dAction;
private boolean aborted=false;
  
public ConceptDefinitionForm(Frame fr, 
			String nm, 
			String desc) {

    jd = new JDialog(fr, "Definition", true);
    parent = fr;
    
    JPanel jp = new JPanel();
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints gbc;
    jp.setLayout(gbl);
    // jp.setLayout(new GridLayout(4,2));
    jp.setBorder(new TitledBorder("Concept Definition"));
    JPanel jp1 = new JPanel(new FlowLayout());
    
    dAction = new ActionListener() {
      public void actionPerformed(ActionEvent e) { doAction(ACCEPT); }
    };    
    
    JLabel namel = new JLabel("Concept name:");
    name = new JTextField(nm,30);
    name.addActionListener(dAction);
    name.addFocusListener(new FocusAdapter() {
      public void focusGained(FocusEvent e) { 
        name.selectAll();
      }
    });
    name.setBorder(new LineBorder(Color.black));
    namel.setLabelFor(name);
    namel.setDisplayedMnemonic('c');
    addLabelAndField(namel, name, gbl, jp);

    JLabel descl = new JLabel("Description:");
    description = new JTextArea(desc,10,30);
    description.setBorder(new LineBorder(Color.black));
    descl.setLabelFor(description);
    descl.setDisplayedMnemonic('d');
    addLabelAndArea(descl, description, gbl, jp);
    
    JButton jok = new JButton("Ok");
    jok.setMnemonic('o');
    jok.addActionListener(dAction);
    jp1.add(jok);

    JButton jcancel = new JButton("CANCEL");
    jcancel.setMnemonic('a');
    jcancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) { doAction(CANCEL); }
    });
    jp1.add(jcancel);

    jd.getContentPane().add(jp, BorderLayout.CENTER);
    jd.getContentPane().add(jp1, BorderLayout.SOUTH);
    jd.pack();
    jd.setLocationRelativeTo(parent);
  }

  public void show() {
    jd.show();
  }

public boolean aborted()      { return aborted; }
public String getName() { return name.getText(); }
public String getDescription() {return description.getText(); }

public void doAction(int action) {
  switch (action) {
  case ACCEPT:
    aborted = false;
    break;
  case CANCEL:
    aborted = true;
    break;
  }
  jd.setVisible(false);
}

private void addLabelAndField(JLabel l, 
			      JTextField f, 
			      GridBagLayout gbl, 
			      Container c) {
  GridBagConstraints gbc;
  // do the stuff for the label;
  gbc = new GridBagConstraints();
  gbc.weightx = 0;
  gbc.weighty = 100;
  gbc.gridx = 0;
  gbc.gridy = 0;
  gbc.gridwidth = 1;
  gbc.gridheight = 1;
  gbc.anchor = GridBagConstraints.NORTHEAST;
  gbl.setConstraints(l, gbc);
  c.add(l);
  // do the stuff for the field;
  gbc = new GridBagConstraints();
  gbc.weightx = 100;
  gbc.weighty = 0;
  gbc.gridx = 1;
  gbc.gridy = 0;
  gbc.gridwidth = 3;
  gbc.gridheight = 1;
  gbc.anchor = GridBagConstraints.NORTH;
  gbc.fill = GridBagConstraints.HORIZONTAL;
  gbl.setConstraints(f, gbc);
  c.add(f);
}

private void addLabelAndArea(JLabel l, 
			     JTextArea a, 
			     GridBagLayout gbl, 
			     Container c) {
  GridBagConstraints gbc;
  // do the stuff for the label;
  gbc = new GridBagConstraints();
  gbc.weightx = 0;
  gbc.weighty = 100;
  gbc.gridx = 0;
  gbc.gridy = 1;
  gbc.gridwidth = 1;
  gbc.gridheight = 1;
  gbc.anchor = GridBagConstraints.NORTHEAST;
  gbl.setConstraints(l, gbc);
  c.add(l);
  // do the stuff for the field;
  gbc = new GridBagConstraints();
  gbc.weightx = 100;
  gbc.weighty = 100;
  gbc.gridx = 1;
  gbc.gridy = 1;
  gbc.gridwidth = 3;
  gbc.gridheight = 10;
  //      gbc.anchor = GridBagConstraints.NORTHWEST;
  gbc.fill = GridBagConstraints.BOTH;
  gbl.setConstraints(a, gbc);
  c.add(a);
}
}
