package img.fact.client;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.net.*;
import lispwrapper.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import img.fact.cexpr.*;
import img.fact.*;
import img.util.*;

/** I'm a little client application that talks to fact using the corba
 * interface.  
 * @author SKB */

public class LittleClient extends JFrame {

  ClientApplication applet;
  JFrame frame;

public LittleClient() {
  applet = new ClientApplication(this);

  getContentPane().add(applet, "Center");
  addWindowListener(new WindowAdapter() {
    public void windowClosing(WindowEvent e) {
      setVisible(false);
      applet.stop();
      applet.destroy();
      dispose();
      System.exit(0);
    }});
  applet.init();
  applet.start();
  setSize(applet.getPreferredSize());
  pack();
  show();
}

public void connect(ClientHandler ch) {
  applet.connect(ch);
}

public void setDefaultNSHost(String nsHost) {
  applet.setDefaultNSHost(nsHost);
}
public void setDefaultNSPort(String nsPort) {
  applet.setDefaultNSPort(nsPort);
}
public void setDefaultServerName(String serverName) {
  applet.setDefaultServerName(serverName);
}

public static void main(String[] args) {
  if (System.getProperty("WIN")!=null) {
    try {
      UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    } catch (ClassNotFoundException ex) {
    } catch (InstantiationException ex) {
    } catch (IllegalAccessException ex) {
    } catch (UnsupportedLookAndFeelException ex) {
    }
  }

  LittleClient lc = new LittleClient();

  Hashtable argSpec = new Hashtable();
  argSpec.put("nsHost", new Integer(1));
  argSpec.put("nsPort", new Integer(1));
  argSpec.put("serverName", new Integer(1));
  argSpec.put("help", new Integer(0));
  
  img.util.CommandLineArguments cla = 
    new img.util.CommandLineArguments(argSpec);
  String nsHost = System.getProperty("img.fact.nshost", "localhost");
  String nsPort = System.getProperty("img.fact.nsport", "8000");
  String serverName = System.getProperty("img.fact.servername", "FaCTServer");
  try {
    String[] tmp;
    cla.setArgs(args);
    if (cla.flagPresent("help")) {
      printHelp();
      System.exit(0);
    }
    tmp = cla.argsForSelector("nsHost");
    if (tmp!=null) {
      nsHost = tmp[0];
    }
    tmp = cla.argsForSelector("nsPort");
    if (tmp!=null) {
      nsPort = tmp[0];
    }
    tmp = cla.argsForSelector("serverName");
    if (tmp!=null) {
      serverName = tmp[0];
    }
  } catch (Exception ex) {
    System.err.println("Usage: java img.fact.client.LittleClient [-help] [-nsHost host] [-nsPort port] [-serverName name]");
    System.exit(1);
  }

  lc.applet.setDefaultNSHost(nsHost);
  lc.applet.setDefaultNSPort(nsPort);
  lc.applet.setDefaultServerName(serverName);
}

public static void printHelp() {
  System.out.println("Usage: java img.fact.client.LittleClient [options]");
  System.out.println("Starts a FaCT client");
  System.out.println("\t-nsHost\t\tDefault host running naming service");
  System.out.println("\t-nsPort\t\tDefault port running naming service");
  System.out.println("\t-serverName\tDefault server name");
  System.out.println("\t-help\t\tPrint this message");
}
}

